package people;
import java.util.*;

public class PeopleDatabaseDynamicImpl implements PeopleDatabase{

    private ArrayList<Person> persons;
    private int indice;

    public PeopleDatabaseDynamicImpl(){
	persons = new ArrayList<Person>();
    }

    public void add(Person p){
	persons.add(p);
	
    }
    public Person get(String id){
	Person per = null;
	for (Person p : persons)
	    if (p!= null && p.getUniqueId() == id)
		per = p;
	return per;
    }
    public int getPersonCount(){
	int s = 0;
	for (Person p : persons)
	    if (p != null)
		s++;
	return s;
    }
	
    
    public int getEmployeeCount(){
	int s = 0;
	for (Person p : persons)
	    if (p instanceof Employee)
		s++;
	return s;
    }
    public int getStudentCount(){
	int s = 0;
	for (Person p : persons)
	    if (p instanceof Student)
		s++;
	return s;
    }
    
    public double getStudentAverageAge(){
	if (getStudentCount() != 0){
	    double totalage = 0;
	    for (Person p : persons)
		if (p instanceof Student)
		    totalage+= ((Student)p).getAge();
	    return totalage/getStudentCount();
	}
	else return 0;
    }

    public double getAverageSalary(){
	if (getEmployeeCount() != 0){
	    double s = 0;
	    for (Person p : persons)
		if (p instanceof Employee)
		    s+= ((Employee)p).getSalary();
	    return s/getEmployeeCount();
	}
	else return 0;
	    
    }
    public Person getOldestPerson(){
	if (persons.size() != 0){
	    Person old = persons.get(0);
	    for (Person p : persons)
		if ( p != null && p.getAge() > old.getAge())
		    old = p;
	    return old;
	}
	return null;
    
    }
    
    public Employee getRichestEmployee(){
	if (persons.size() != 0){
	    Employee rich = (Employee)persons.get(0);
	    for (Person p : persons)
		if (p != null && p instanceof Employee){
		    Employee e = (Employee)p;
		    if (e.getSalary() >= rich.getSalary())
			rich = e;
		    
		}
	    return rich;
	}
	return null;
    }

}
