package people;

public abstract class PersonImpl implements Person{
    private int age;
    private String nom;

    protected PersonImpl(String nom, int age){
	this.age = age;
	this.nom = nom;
    }
    
    public PersonImpl(PersonImpl p){
	this(p.nom, p.age);
    }

    public int getAge(){
	return age;
    }

    public String getName(){
	return nom;
    }

    public void setAge(int age){
	this.age = age;
    }

    public abstract String getUniqueId();

    public String toString(){
	return "["+this.getUniqueId()+"] " +this.getName()+ " (age: " + this.getAge()+")";
    }

    public boolean equals(Object o){
	if (!(o instanceof PersonImpl) || o == null)
	    return false;
	else {
	    PersonImpl p = (PersonImpl)o;
	    return ((p.getName() == this.getName() && p.getAge() == this.getAge() && p.getUniqueId().equals(this.getUniqueId())) || o == this);
	}
    }
}
